<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>IoT-Pay - Web Payment In Credit Card Test</title>
    <link rel="icon" type="image/png" href="https://develop.iotpay.ca/imgs/favicon64x64.png">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
          integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
</head>
<body>
<nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand mx-auto" href="#">
        <img src="https://develop.iotpay.ca/imgs/iot-logo.png" height="50" alt="">
    </a>
</nav>
<?php
session_start();
require_once('Utility.php');
$Utility = new Utility();
if (!$_POST['amount']) {
    file_put_contents("./log.txt", date("Y/m/d") . "   " . date("h:i:sa") . "   " . "ReturnURL" . "   " . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] . "\r\n", FILE_APPEND);
    $result = $_GET['retCode'];
    if ($result == 'SUCCESS') {
        $merchantKey = $_SESSION["merchantKey"];
        parse_str($_SERVER['QUERY_STRING'], $arr);
        unset($arr["sign"]);
        $sort_array = $Utility->arg_sort($arr);
        $mysign = $Utility->build_mysign($sort_array, $merchantKey, "MD5");
        $backsign = $_GET["sign"];
       // if ($mysign == $backsign) {
            if ($_GET["retCode"] == 'SUCCESS') {
                $result = 'success';
            } else {
                $result = 'fail';
            }
            $cardId = $_SESSION["cardId"];
            $_SESSION["cardId"] = $cardId;
       // } else {
      //      $result = 'fail';
      //      $_GET['errMsg'] = 'sign verify fail';
       // }
    }
    ?>
    <div class="container">
        <div class="col-xl-8 mx-auto py-5">
            <form method="post">
                <?php if ($result == 'success') { ?>
                    <div class="form-group">
                        <div style="text-align: center"><h1>Add Card Successful</h1></div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Card Id</label>
                        <div class="col-md-9">
                            <?php echo $_SESSION['cardId']; ?>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="amount" class="col-md-3 col-form-label">Amount</label>
                        <div class="col-md-9">
                            <input type="text" class="form-control" id="amount" name="amount"
                                   placeholder="Enter Amount" required>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="jobNo" class="col-md-3 col-form-label">loginName</label>
                        <div class="col-md-9">
                            <input type="text" class="form-control" id="jobNo" name="jobNo"
                                   placeholder="Enter loginName" required>
                        </div>
                    </div>
                    <div class="form-group row">
                        <input type="submit" class="btn btn-primary btn-block mt-5" value="Purchase With Token"/>
                    </div>
                <?php } else { ?>
                    <div class="form-group">
                        <div style="text-align: center"><h1>Add Card Fail</h1></div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Return Code</label>
                        <div class="col-md-9">
                            <?php echo $_GET['retCode']; ?>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Return Message</label>
                        <div class="col-md-9">
                            <?php echo $_GET['retMsg']; ?>
                        </div>
                    </div>
                <?php } ?>
                <div class="form-group row">
                    <input type="button" class="btn btn-primary btn-block mt-5" value="Return"
                           onclick="location.href = 'addcard.html'"/>
                </div>
            </form>
        </div>
    </div>
    <?php
} else {
    $merchantId = $_SESSION['merchantId'];
    $merchantKey = $_SESSION['merchantKey'];
    $cardId = $_SESSION['cardId'];
    $url = 'https://ccapi.iotpaycloud.com/v3/cc_purchasewithtoken';
    $amount = $_POST['amount'];
    $jobNo = $_POST['jobNo'];
    $mchOrderNo = $_SERVER['REQUEST_TIME'];
    $_SESSION["mchOrderNo"] = $mchOrderNo;
    $arr = array(
        'mchId' => $merchantId,
        'mchOrderNo' => $mchOrderNo,
        'cardId' => $cardId,
        'amount' => intval($amount * 100),
        'currency' => 'CAD',
        'loginName' => $jobNo,
        'subject' => 'test',
        'body' => 'test&=',
    );
    $sort_array = $Utility->arg_sort($arr);
    $arr['sign'] = $Utility->build_mysign($sort_array, $merchantKey, "MD5");//Generate signature parameter sign
    $param = json_encode($arr);
  //echo $param;
    $resBody = $Utility->request($url, $param);//Submit to the gateway
  //echo  $resBody;
    $res = json_decode($resBody, true);
    //echo $resBody;
    if ($res['retCode'] == 'SUCCESS') {
        
        $payOrderId = $res['retData']['payOrderId'];
        $_SESSION["payOrderId"] = $payOrderId;
     	 $status = $res['retData']['status'];
        $i=0;
        while($status !=2 &&  $status !=3)
        {
           	$payorderid = $res['retData']['payOrderId'];
            $arr = array(
                'mchId' => $merchantId,
                'payOrderId' => $payorderid,
            );
            $sort_array = $Utility->arg_sort($arr);
            $arr['sign'] = $Utility->build_mysign($sort_array, $merchantKey, "MD5");//Generate signature parameter sign
            $param = json_encode($arr);
            $resBody = $Utility->request('https://ccapi.iotpaycloud.com/v3/cc_query', $param);//Submit to the gateway
            $res = json_decode($resBody, true);
            $status = $res['retData']['status'];
        	
            if($i>10){
                
              	break;
            }
            sleep(1);
            $i++;        
        }
      if($status ==2 || $status ==3 ){
            	$result = 'success';
            }
      
      
    } else {
        $result = 'fail';
        $msg = $res['retMsg'];
    }
    ?>
    <div class="container">
        <div class="col-xl-8 mx-auto py-5">
            <form method="post">
                <?php if ($result == 'success') { ?>
                    <div class="form-group">
                        <div style="text-align: center"><h1>Payment Successful</h1></div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Pay Order Id</label>
                        <div class="col-md-9">
                            <?php echo $payOrderId; ?>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Transaction Number</label>
                        <div class="col-md-9">
                            <?php echo $res['retData']['transNum']; ?>
                        </div>
                    </div>
                	<div class="form-group row">
                        <label for="apiKey" class="col-md-3">Order Status</label>
                        <div class="col-md-9">
                            <?php echo $res['retData']['status']; ?>
                        </div>
                    </div>
                    <div class="form-group row">
                        <input type="button" class="btn btn-primary btn-block mt-5" value="Void"
                               onclick="location.href = 'refund.php'"/>
                    </div>
                    <div class="form-group row">
                        <input type="button" class="btn btn-primary btn-block mt-5" value="Refund"
                               onclick="location.href = 'refund.php'"/>
                    </div>
                <?php } else { ?>
                    <div class="form-group">
                        <div style="text-align: center"><h1>Payment Fail</h1></div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Return Code</label>
                        <div class="col-md-9">
                            <?php echo $res['retCode']; ?>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Return Message</label>
                        <div class="col-md-9">
                            <?php echo $msg; ?>
                        </div>
                    </div>
                <?php } ?>
                <div class="form-group row">
                    <input type="button" class="btn btn-primary btn-block mt-5" value="Return"
                           onclick="location.href = '<?php echo $_SESSION["path"]; ?>.html'"/>
                </div>
            </form>
        </div>
    </div>
    <?php
}
?>
</body>
</html>