<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>IoT-Pay - Web Payment In Credit Card Test</title>
    <link rel="icon" type="image/png" href="https://develop.iotpay.ca/imgs/favicon64x64.png">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
          integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
</head>
<body>
<nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand mx-auto" href="#">
        <img src="https://develop.iotpay.ca/imgs/iot-logo.png" height="50" alt="">
    </a>
</nav>
<?php
session_start();
if (!$_POST['payorderid'] && !$_POST['mon']) {
    ?>
    <div class="container">
        <div class="col-xl-8 mx-auto py-5">
            <div class="mb-4">
                <h3>Query Test</h3>
            </div>
            <form method="post">
                <div class="form-group row">
                    <label for="merchantid" class="col-md-3 col-form-label">Merchant Id</label>
                    <div class="col-md-9">
                        <input type="text" class="form-control" id="merchantid" name="merchantid"
                               placeholder="Enter Merchant Id" value="<?php echo $_SESSION["merchantId"]; ?>">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="merchantKey" class="col-md-3 col-form-label">Merchant Key</label>
                    <div class="col-md-9">
                        <input type="text" class="form-control" id="merchantKey" name="merchantKey"
                               placeholder="Enter Merchant Key" value="<?php echo $_SESSION["merchantKey"]; ?>">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="payorderid" class="col-md-3 col-form-label">Pay Order Id</label>
                    <div class="col-md-9">
                        <input type="text" class="form-control" id="payorderid" name="payorderid"
                               placeholder="Enter Pay Order Id" value="">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="mon" class="col-md-3 col-form-label">Merchant Order No.</label>
                    <div class="col-md-9">
                        <input type="text" class="form-control" id="mon" name="mon"
                               placeholder="Enter Merchant Order No." value="<?php echo $_SESSION["mchorderid"]; ?>">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="pon" class="col-md-12 col-form-label">Merchant Order No. and Payment Order No. only need
                        to
                        fill one</label>
                </div>
                <input type="submit" class="btn btn-primary btn-block mt-5"></input>
            </form>
        </div>
    </div>
    <?php
} else {
    require_once('Utility.php');
    $merchant_id = $_POST['merchantid'];
    $merchant_key = $_POST['merchantKey'];
    $url = 'https://ccapi.iotpaycloud.com/v3/cc_query';
    $paymentordernum = $_POST['payorderid'];
    $merchantordernum = $_POST['mon'];
    $Utility = new Utility();
    $loginname = $_POST['loginname'];
    $payorderid = $_POST['payorderid'];
    $arr = array(
        'mchId' => $merchant_id,
        'mchOrderNo' => $merchantordernum,
        'payOrderId' => $paymentordernum,
    );
    $sort_array = $Utility->arg_sort($arr);
    $arr['sign'] = $Utility->build_mysign($sort_array, $merchant_key, "MD5");//Generate signature parameter sign
    $param = json_encode($arr);
    $resBody = $Utility->request($url, $param);//Submit to the gateway
  echo $resBody;
    ?>
    <div class="container">
        <div class="col-xl-8 mx-auto py-5">
            <form method="post">
                <div class="form-group row">
                    <div class="col-md-12" style="white-space: normal; word-break: break-all">
                        <?php echo $resBody; ?>
                    </div>
                </div>
                <div class="form-group row">
                    <input type="button" class="btn btn-primary btn-block mt-5" value="Return"
                           onclick="location.href = 'query.php'"/>
                </div>
            </form>
        </div>
    </div>
    <?php
}
?>
</body>
</html>