<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>IoT-Pay - Web Payment In Credit Card Test</title>
    <link rel="icon" type="image/png" href="https://develop.iotpay.ca/imgs/favicon64x64.png">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
          integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
</head>
<body>
<nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand mx-auto" href="#">
        <img src="https://develop.iotpay.ca/imgs/iot-logo.png" height="50" alt="">
    </a>
</nav>
<?php
session_start();
if (!$_POST['loginname']) {
    ?>
    <div class="container">
        <div class="col-xl-8 mx-auto py-5">
            <div class="mb-4">
                <h3>Refund / Void Test</h3>
            </div>
            <form method="post">
                <div class="form-group row">
                    <label for="merchantid" class="col-md-3 col-form-label">Merchant Id</label>
                    <div class="col-md-9">
                        <input type="text" class="form-control" id="merchantid" name="merchantid"
                               placeholder="Enter Merchant Id" value="<?php echo $_SESSION["merchantId"]; ?>">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="merchantKey" class="col-md-3 col-form-label">Merchant Key</label>
                    <div class="col-md-9">
                        <input type="text" class="form-control" id="merchantKey" name="merchantKey"
                               placeholder="Enter Merchant Key" value="<?php echo $_SESSION["merchantKey"]; ?>">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="orderamount" class="col-md-3 col-form-label">Refund Amount</label>
                    <div class="col-md-9">
                        <input type="text" class="form-control" id="orderamount" name="orderamount"
                               placeholder="Enter OrderAmount">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="loginname" class="col-md-3 col-form-label">Login Name</label>
                    <div class="col-md-9">
                        <input type="text" class="form-control" id="loginname" name="loginname"
                               placeholder="Enter Login Name">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="payorderid" class="col-md-3 col-form-label">Pay Order Id</label>
                    <div class="col-md-9">
                        <input type="text" class="form-control" id="payorderid" name="payorderid"
                               placeholder="Enter Pay Order Id" value="">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="inputType" class="col-md-3 col-form-label">Refund Type</label>
                    <div class="col-md-9">
                        <select class="form-control" id="inputType" name="refundType">
                            <option value="Void" selected>Void</option>
                            <option value="Refund">Refund</option>
                        </select>
                    </div>
                </div>
                <input type="submit" class="btn btn-primary btn-block mt-5"></input>
            </form>
        </div>
    </div>
    <?php
} else {
    require_once('Utility.php');
    $merchant_id  = $_POST['merchantid'];
    $merchant_key = $_POST['merchantKey'];
    if ($_POST['refundType'] == 'Void') {
        $url = 'https://ccapi.iotpaycloud.com/v3/cc_void';
    } else {
        $url = 'https://ccapi.iotpaycloud.com/v3/cc_refund';
    }
    $order_amount = $_POST['orderamount'];
    $order_sn = $_SERVER['REQUEST_TIME'];
    $Utility = new Utility();
    $loginname = $_POST['loginname'];
    $payorderid = $_POST['payorderid'];
    $arr = array(
        'mchId' => $merchant_id,
        'mchRefundNo' => $order_sn,
        'loginName' => $loginname,
        'currency' => 'CAD',
        'refundAmount' => intval($order_amount * 100),
        'payOrderId' => $payorderid,
    );
    $sort_array = $Utility->arg_sort($arr);
    $arr['sign'] = $Utility->build_mysign($sort_array, $merchant_key, "MD5");//Generate signature parameter sign
    $param = json_encode($arr);
    $resBody = $Utility->request($url, $param);//Submit to the gateway

     $result = 'fail';
    $res = json_decode($resBody, true);
    if ($res['retCode'] == 'SUCCESS') {
      
      	$status = $res['retData']['status'];
        $i=0;
        while($status !=2 &&  $status !=3)
        {
           	$payorderid = $res['retData']['payOrderId'];
            $arr = array(
                'mchId' => $merchant_id,
                'payOrderId' => $payorderid,
            );
            $sort_array = $Utility->arg_sort($arr);
            $arr['sign'] = $Utility->build_mysign($sort_array, $merchant_key, "MD5");//Generate signature parameter sign
            $param = json_encode($arr);
            $resBody = $Utility->request('https://ccapi.iotpaycloud.com/v3/cc_query', $param);//Submit to the gateway
            $res = json_decode($resBody, true);
            $status = $res['retData']['status'];
        	if($status ==2 || $status ==3 ){
            	$result = 'success';
            }
            if($i>10){
                
              	break;
            }
            sleep(1);
            $i++;        
        }
      if($status ==2 || $status ==3 ){
            	$result = 'success';
            }
    } else {
        $result = 'fail';
        $msg = $res['retMsg'];
    }
    echo $resBody;
    ?>
    <div class="container">
        <div class="col-xl-8 mx-auto py-5">
            <form method="post">
                <?php if ($result == 'success') { ?>
                    <div class="form-group">
                        <div style="text-align: center"><h1><?php echo $_POST['refundType'];?> Successful</h1></div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Pay Order Id</label>
                        <div class="col-md-9">
                            <?php echo $res['retData']['payOrderId']; ?>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Transaction Number</label>
                        <div class="col-md-9">
                            <?php echo $res['retData']['transNum']; ?>
                        </div>
                    </div>
                <?php } else { ?>
                    <div class="form-group">
                        <div style="text-align: center"><h1>Refund Fail</h1></div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Return Code</label>
                        <div class="col-md-9">
                            <?php echo $res['retCode']; ?>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="apiKey" class="col-md-3">Return Message</label>
                        <div class="col-md-9">
                            <?php echo $msg; ?>
                        </div>
                    </div>
                <?php } ?>
                <div class="form-group row">
                    <input type="button" class="btn btn-primary btn-block mt-5" value="Return"
                           onclick="location.href = '<?php echo $_SESSION["path"]; ?>.html'"/>
                </div>
            </form>
        </div>
    </div>
    <?php
}
?>
</body>
</html>